ureadahead source needs "tracing_enabled" changed to "tracing_on" for 12.04.3

Bug #1237042 reported by Doug
68
This bug affects 13 people
Affects Status Importance Assigned to Milestone
ureadahead (Ubuntu)
Confirmed
Undecided
Unassigned

Bug Description

On a fresh install of Ubuntu 12.04.3 (64-bit), ureadahead was always exiting with status code 5.

When manually run as: sudo /sbin/ureadahead --force-trace --debug
The output is:
Counted 4 CPUs
trace: Missing uselib tracing: No such file or directory
ureadahead: Error while tracing: No such file or directory

The uselib tracing notice is not important. The "error while tracing" notice lead me to compare ureadahead sources between 12.04.3 and 13.04. Note that ureadahead in 13.04 works. I noticed this difference on lines 195 and 232:
 if (set_value (dfd, "tracing_enabled",
vs:
 if (set_value (dfd, "tracing_on",

This change is mentioned in the changelog as:

ureadahead (0.100.0-13) raring; urgency=low
  * src/trace.c: tracing_enabled is deprecated and gone, switch to tracing_on
    (LP: #1085766).
 -- Andy Whitcroft <email address hidden> Fri, 11 Jan 2013 12:05:17 +0000

I suspect that this issue occurs in 12.04.3 because it is now using the newer raring kernel 3.8.0-31. Previous flavors of 12.04 such as 12.04.2 do not seem to exhibit this ureadahead issue, probably because the kernel is older 3.5.xx.

As a proof-of-concept test, I hex edited the 12.04.3 /sbin/ureadahead to change "tracing_enabled" to "tracing_on". Upon reboot, now ureadahead works, generates the /var/lib/ureadahead/pack file, and it does not report status code 5.

Another workaround is to use the ureadahead binary from 13.04, but the updated /lib/x86_64-linux-gnu/libext2fs.so.2.4 is also required from 13.04.

$ lsb_release -rd
Description: Ubuntu 12.04.3 LTS
Release: 12.04

$ apt-cache policy ureadahead
ureadahead:
  Installed: 0.100.0-12
  Candidate: 0.100.0-12
  Version table:
 *** 0.100.0-12 0
        500 http://mirror.peer1.net/ubuntu/ precise/main amd64 Packages
        100 /var/lib/dpkg/status

Revision history for this message
Doug (dougmc) wrote :

Oh I forgot to mention, since this issue IS already fixed in 13.04 the easy fix for 12.04.3 is to update the ureadahead package for 12.04.3 to include the fixes from 13.04.

Revision history for this message
Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in ureadahead (Ubuntu):
status: New → Confirmed
Revision history for this message
François Seguin (francois-seguin) wrote :

Hello,
I can confirm this bug on a 12.04.4 amd64 with kernel 3.8.0-35-generic.
Rebuilding the package 'ureadahead' (0.100.0-12), replacing all occurences of "tracing_enabled" to "tracing_on" in file trace.c, gives a working binary.

Revision history for this message
Kirill Kabardin (kkabardin) wrote :

Doug, thanks for investigating source of the problem and provided workaround. I managed to fix ureadahead on my system with provided information.

It is sad that this regression was not fixed in 12.04.4

Revision history for this message
StoatWblr (stoatwblr) wrote :

This may have been fixed in 13.04 but it's broken again in 14.04

Revision history for this message
Paul Crawford (psc-sat) wrote :

Still broken on 12.04.5 recently updated:

$ apt-cache policy ureadahead
ureadahead:
  Installed: 0.100.0-12
  Candidate: 0.100.0-12
  Version table:
 *** 0.100.0-12 0
        500 http://gb.archive.ubuntu.com/ubuntu/ precise/main amd64 Packages
        100 /var/lib/dpkg/status

$ uname -a
Linux pscpc 3.13.0-34-generic #60~precise1-Ubuntu SMP Wed Aug 13 15:55:33 UTC 2014 x86_64 x86_64 x86_64 GNU/Linux

Also finding nothing in /var/lib/ureadahead suggesting it never worked on my system (installed as 12.04.4 I think)

Revision history for this message
Andreas Bartels (andreas-bartels) wrote :

I've got the fault in 14.04 .

what will it cause. Is it enough to change out the ureadahead from 13.04 to 14.04

Revision history for this message
Nicolas Produit (nicolas-produit-unige) wrote :

I have got problem in 15.10!
#aystemctl --state=failed
● ureadahead.service loaded failed failed Read required files in advance

#journalctl -u ureadahead
Nov 06 09:10:07 yoga ureadahead[235]: ureadahead: Error while tracing: No such file or directory
Nov 06 09:10:07 yoga ureadahead[235]: Counted 4 CPUs
Nov 06 09:11:10 yoga systemd[1]: Stopped Read required files in advance.

#apt-cache policy ureadahead
ureadahead:
  Installed: 0.100.0-19
  Candidate: 0.100.0-19
  Version table:
 *** 0.100.0-19 0
        500 http://archive.ubuntu.com/ubuntu/ wily/main amd64 Packages
        100 /var/lib/dpkg/status

Revision history for this message
Dominic Raferd (dominic-timedicer) wrote :

I also have this problem with Ubuntu 15.10, same output as Nicolas:

$ sudo systemctl status ureadahead
● ureadahead.service - Read required files in advance
   Loaded: loaded (/lib/systemd/system/ureadahead.service; enabled; vendor preset: enabled)
   Active: failed (Result: exit-code) since Sat 2016-01-30 07:07:07 GMT; 15min ago
  Process: 233 ExecStart=/sbin/ureadahead (code=exited, status=5)
 Main PID: 233 (code=exited, status=5)

Jan 30 07:07:07 dicer2 ureadahead[233]: ureadahead: Error while tracing: No such file or directory
Jan 30 07:07:07 dicer2 ureadahead[233]: Counted 2 CPUs
Jan 30 07:08:19 dicer2 systemd[1]: Stopped Read required files in advance.

Revision history for this message
MrTux (mrtux) wrote :

I also have same problem in Ubuntu 15.10 (amd64)

Revision history for this message
Brian O'Connor (bris-pi-guy) wrote :

I also have this problem with Ubuntu 16.04 LTS.

ureadahead.service - Read required files in advance
   Loaded: loaded (/lib/systemd/system/ureadahead.service; enabled; vendor preset: enabled)
   Active: failed (Result: exit-code) since Fri 2016-05-13 06:12:57 AEST; 13min ago
  Process: 73 ExecStart=/sbin/ureadahead (code=exited, status=5)
 Main PID: 73 (code=exited, status=5)

May 13 06:12:57 XXX ureadahead[73]: ureadahead: Error while tracing: No such file or directory
May 13 06:12:57 XXX ureadahead[73]: Counted 4 CPUs
May 13 06:14:01 XXX systemd[1]: Stopped Read required files in advance.
Warning: Journal has been rotated since unit was started. Log output is incomplete or unavailable.

XXX:~$ lsb_release -rd
Description: Ubuntu 16.04 LTS
Release: 16.04
XXX:~$ apt-cache policy ureadahead
ureadahead:
  Installed: 0.100.0-19
  Candidate: 0.100.0-19
  Version table:
 *** 0.100.0-19 500
        500 http://ports.ubuntu.com xenial/main armhf Packages
        100 /var/lib/dpkg/status
XXX:~$

Revision history for this message
Lucas Magasweran (lucasrangit) wrote :

The following error could also indicate that your kernel doesn't have the required tracepoints.

ureadahead: Error while tracing: No such file or directory

If you're not running a stock Ubuntu kernel you will need a patch [1] (worked on my 4.14 Debian kernel). Unfortunately, these trace events will not be upstreamed [2].

[1] http://kernel.ubuntu.com/git/ubuntu/ubuntu-xenial.git/commit/?h=hwe&id=7744c33fdad887074a481fd4d21ccb6670ac62e6

[2] https://patchwork.kernel.org/patch/9254717/

To post a comment you must log in.
This report contains Public information  
Everyone can see this information.

Other bug subscribers